#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <stdlib.h>

#include "prep.h"
#include "pager.h"
#include "srv.h"

// http://かhttps://で始まるかどうか
bool checkprefix (const char *url) {
  return strncmp("http://", url, 7) == 0 || strncmp("https://", url, 8) == 0;
}

int main (int argc, char *argv[]) {
  if (argc == 2) {
    if (!strcmp("-v", argv[1])) {
      printf("hozonsite-"VERSION);
      printf("\n");
      return(0);
    }
    else if (!strcmp("-s", argv[1])) {
      startsrv(9920);
    }
    else {
      if (checkprefix(argv[1]) == 1) {
        char * path = preparepage(argv[1]); // mkdir等
        getpage(argv[1], path); // ページの保存
        scanpage(argv[1], path);
        free(path);
      }
      else {
        printf("URLは不正です。終了…\n");
        return(0);
      }
    }
  }
  else if (argc == 3 && !strcmp("-s", argv[1])) {
    char *ptr;
    int port = strtol(argv[2], &ptr, 10);
    startsrv(port);
  }
  else {
    printf("使い方：\n");
    printf("hozonsite -v              : バージョンの確認\n");
    printf("hozonsite -s <ポート番号> : ウェブサーバーの実行\n");
    printf("hozonsite <URL>           : コマンドラインでウェブサイトを保存する\n");
    return(0);
  }

  return(0);
}
